/**************************************************************************************************/
// ★desktop.js
//
// ▼メモ
//  - TODO・検討箇所がある場合、記述。
//
// ▼更新履歴
// 2014.12.26 新規作成(Makoto.T)
//                                                           Copyright(C)2014 TIME CONCIER Co.,Ltd.
/**************************************************************************************************/
(function (PLUGIN_ID) {

    "use strict";

/**************************************************************************************************/
// イベントハンドラ
/**************************************************************************************************/

    /******************************************************/
    // 詳細画面"表示"のタイミングで実行
    /******************************************************/
    function initShowPage (event) {

        var record = event.record;

        // プラグインIDの設定
        var KEY = PLUGIN_ID;

        //設定値読み込み用変数
        var config = kintone.plugin.app.getConfig(KEY);

        //設定値読み込み
        if (!config) return false;

        // 選択したフィールドの値要素をGoogleマップへのリンク要素に置き換える
        TcConvMapLink(config, record);

        return event;

    }

    //********************************/
    // イベントハンドラ設定
    //********************************/
    kintone.events.on(['mobile.app.record.detail.show'], initShowPage);

/**************************************************************************************************/
// コール用関数・クラス
/**************************************************************************************************/

    /******************************************************/
    // フィールド値要素のGoogleマップリンク化
    //  pConf		config情報
    //  pRec		record情報
    /******************************************************/
    function TcConvMapLink (pConf, pRec) {

        var trgCode = pConf["prm_addr"];
        var trgVal = pRec[trgCode]['value'];
        var elTrg = kintone.app.record.getFieldElement(trgCode);

        // 対象フィールド値入力チェック
        if ( !trgVal ) { return; }

        // googleマップURL
        var urlMap = "https://www.google.co.jp/maps/place/" + trgVal;


        // <a>タグ生成
        var elHref = document.createElement('a');				// <a>タグ生成
        elHref.href = urlMap;									// リンク先
        elHref.target = "_blank";								// 新規ウインドウで開く
        elHref.textContent = trgVal;							// 表示文字

        var elBtn = document.createElement('input');
        elBtn.type = "button";
        elBtn.name = "地図リンク";
        elBtn.value = "地図を開く";
        addEventListener_(elBtn, 'click', function(){window.open(urlMap, "window_name");});

        // ボタン追加
        var elHead = kintone.mobile.app.getHeaderSpaceElement();
        elHead.appendChild(elBtn);


    }




// イベントリスナーを登録
function addEventListener_(el, type, listener) {
    if (el.addEventListener !== undefined) {
        el.addEventListener(type, listener);
    } else if (el.attachEvent !== undefined) {
        el.attachEvent('on' + type, listener);
    }
}

})(kintone.$PLUGIN_ID);
